%  Steering analysis
%all dimensions are in inches
number=24;
sloop= 3*sin(linspace(0,4*pi,number));
for nloop=1:number
tophandtravelchord=sloop(nloop);


a=3.5;
%a is the length from the arm goes out from the wheel hub
b=6;
%b is the length of the piece that connects to the two tie rods
c=5.5;
%c is the width of the piece that connects to the tie rods-measured from center pivot to outside pivot
d=7.5;
%is the length the handle bars go down below the pivot
e=13;
%e is the length of the handle bars from pivot
f=6;
%f is the y dist back from back edge of connector to where the handle bars connect
beta=60;
radbeta=beta*pi/180;
%beta is the degrees in the xy plane that the handle bar creates with the frame
gamma=60;
radgamma=gamma*pi/180;
%gamma is the degrees in the yz plane that the handle bars make with the frame
%this is the amount the handle moves back from its starting position
%note that the total chord length is two times this
wheelradius=29;
heightofupright=8;
halflenfromwheeltowheel=20;
widthofframe=11;
halfwidthofframe=widthofframe/2;
heightofframe=6;
spacerrotatorisfromframe=1.5;
lenfromleverpivottobackofframe=8;
lengthofframe=30;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
radtophandletravel=tophandtravelchord/e
deghandle=radtophandletravel*180/pi;
botxtravel=sin(radtophandletravel)*d
radturnofconnectingpiece=sin(botxtravel/c);
traveloftopconx=sin(radturnofconnectingpiece)*b
radturnofwheel=sin(traveloftopconx/a);
degturnofwheel=radturnofwheel*180/3.14159
radbeta=beta*3.14159/180;
%now im going to solve for the forces
%all forces are in pounds
F1=15;
%f1 is the force applied in the handle.  All forces will be reference from this force so i made the force 1lbs
F2=F1*e/d;
F3=F2;
forcetierod=F1*e*c/b/d
momaboutwheel=F1*e*c*a/b/d




%Locations of points
%pt 0 0 0 is the pivot point of the rotator
A = [0 0 0]; nA=1;
B = [b*sin(radturnofconnectingpiece) b*cos(radturnofconnectingpiece) 0]; nB=2;
C = [-c*cos(radturnofconnectingpiece) c*sin(radturnofconnectingpiece) 0]; nC=3;
D = [c*cos(radturnofconnectingpiece) -c*sin(radturnofconnectingpiece) 0]; nD=4;
E = [halflenfromwheeltowheel b+a 0]; nE=5;
F = [-halflenfromwheeltowheel b+a 0]; nF=6;
G = [-halflenfromwheeltowheel+sin(radturnofwheel)*a b+a-a*cos(radturnofwheel) 0]; nG=7;
H = [0 -f-lenfromleverpivottobackofframe spacerrotatorisfromframe]; nH=8;
I = [halflenfromwheeltowheel+sin(radturnofwheel)*a b+a-a*cos(radturnofwheel) 0]; nI=9;
J = [0 -f-lenfromleverpivottobackofframe+lengthofframe spacerrotatorisfromframe]; nJ=10;
K = [halfwidthofframe -f heightofframe+spacerrotatorisfromframe]; nK=11;
L = [-halfwidthofframe -f heightofframe+spacerrotatorisfromframe]; nL=12;
M = [halfwidthofframe -f-d*sin(radtophandletravel) heightofframe+spacerrotatorisfromframe-d*cos(radtophandletravel)]; nM=13;
N = [-halfwidthofframe -f+d*sin(radtophandletravel) heightofframe+spacerrotatorisfromframe-d*cos(radtophandletravel)]; nN=14;
O = [halfwidthofframe+cos(radbeta)*e -f+sin(radbeta)*e heightofframe+spacerrotatorisfromframe+sin(radgamma)*e]; nO=15;
P = [-halfwidthofframe-cos(radbeta)*e -f+sin(radbeta)*e heightofframe+spacerrotatorisfromframe+sin(radgamma)*e]; nP=16;
Q = [halflenfromwheeltowheel b+a heightofupright]; nQ=17;
R = [-halflenfromwheeltowheel b+a heightofupright]; nR=18;
S = [halfwidthofframe -f-lenfromleverpivottobackofframe heightofframe+spacerrotatorisfromframe]; nS=19;
T = [-halfwidthofframe -f-lenfromleverpivottobackofframe heightofframe+spacerrotatorisfromframe]; nT=20;     
U = [halfwidthofframe -f-lenfromleverpivottobackofframe+lengthofframe heightofframe+spacerrotatorisfromframe]; nU=21;
V = [-halfwidthofframe -f-lenfromleverpivottobackofframe+lengthofframe heightofframe+spacerrotatorisfromframe]; nV=22;
W = [halflenfromwheeltowheel+cos(radturnofwheel)*a b+a+a*sin(radturnofwheel) 1/2*heightofupright]; nW=23;
X = [-halflenfromwheeltowheel-cos(radturnofwheel)*a b+a-a*sin(radturnofwheel) 1/2*heightofupright]; nX=24;
Y = [halflenfromwheeltowheel b+a 1/2*heightofupright]; nY=25;
Z = [-halflenfromwheeltowheel b+a 1/2*heightofupright]; nZ=26;


% array of point coordinates
points=[A;B;C;D;E;F;G;H;I;J;K;L;M;N;O;P;Q;R;S;T;U;V;W;X;Y;Z];
names='ABCDEFGHIJKLMNOPQRSTUVWXYZ'; names=names';
%Connection matrix


connect= [ ...
nA nB;
nA nC;
nA nD;
nB nG;
nB nI;
nE nI;
nY nW;
nF nG;
nZ nX;
nM nK;
nN nL;
nM nD;
nN nC;
nK nO;
nL nP;
nE nQ;
nF nR;
nS nU;
nT nV;
nS nT;
nU nV;
nH nJ;
nH nS;
nH nT;
nJ nU;
nJ nV];


nbars = length(connect(:,1));


t=linspace(0,2*pi,100);

wheel1=[ ...
 -wheelradius*cos(t)*sin(radturnofwheel) + -halflenfromwheeltowheel-cos(radturnofwheel)*a;            %x coord
 wheelradius*cos(t)*cos(radturnofwheel) + b+a-a*sin(radturnofwheel);      %y coord
 1/2*heightofupright+wheelradius*sin(t)            %z coord
 ];

wheel2=[ ...
 -wheelradius*cos(t)*sin(radturnofwheel) + halflenfromwheeltowheel+cos(radturnofwheel)*a;            %x coord
 wheelradius*cos(t)*cos(radturnofwheel) + b+a+a*sin(radturnofwheel);      %y coord
 1/2*heightofupright+wheelradius*sin(t)            %z coord
 ];





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(1)   % 4 views
clf


views=[ ...
0 90;
30 30
0 0;
90 0;
];

for j=1:4
 subplot(2,2,j)
 hold on;
 for i =1:nbars
    if i<=15
        bar = connect(i,:);
        plot3(   points( [bar(1) bar(2)], 1 ), ...
                 points( [bar(1) bar(2)], 2 ), ...
                 points( [bar(1) bar(2)], 3 ),'b'       )
    else
        bar = connect(i,:);
        plot3(   points( [bar(1) bar(2)], 1 ), ...
                 points( [bar(1) bar(2)], 2 ), ...
                 points( [bar(1) bar(2)], 3 ),'r'       )
      
    end          
  end
  plot3(wheel1(1,:), wheel1(2,:), wheel1(3,:),'k')  
  plot3(wheel2(1,:), wheel2(2,:), wheel2(3,:),'k')  

  
  %if j==2; text(points(:,1), points(:,2), points(:,3), names); end;
 axis('equal')
 hold off;
 view(views(j,:))
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(2)  % Just perspective
clf
hold on
views=[0 90];


  for i =1:nbars
        if i<=15
        bar = connect(i,:);
        plot3(   points( [bar(1) bar(2)], 1 ), ...
                 points( [bar(1) bar(2)], 2 ), ...
                 points( [bar(1) bar(2)], 3 ),'b'       )
    else
        bar = connect(i,:);
        plot3(   points( [bar(1) bar(2)], 1 ), ...
                 points( [bar(1) bar(2)], 2 ), ...
                 points( [bar(1) bar(2)], 3 ),'r'       )
      
    end  
 end
  
 plot3(wheel1(1,:), wheel1(2,:), wheel1(3,:),'k')  
 plot3(wheel2(1,:), wheel2(2,:), wheel2(3,:),'k')      
 h=text(points(:,1), points(:,2), points(:,3),  names); 
 axis('equal')
 hold off;
 view(views)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(3)  % Just perspective
clf
hold on
views=[30 30];


  for i =1:nbars
        if i<=15
        bar = connect(i,:);
        plot3(   points( [bar(1) bar(2)], 1 ), ...
                 points( [bar(1) bar(2)], 2 ), ...
                 points( [bar(1) bar(2)], 3 ),'b'       )
    else
        bar = connect(i,:);
        plot3(   points( [bar(1) bar(2)], 1 ), ...
                 points( [bar(1) bar(2)], 2 ), ...
                 points( [bar(1) bar(2)], 3 ),'r'       )
      
    end 
 end
  
 plot3(wheel1(1,:), wheel1(2,:), wheel1(3,:),'k')  
 plot3(wheel2(1,:), wheel2(2,:), wheel2(3,:),'k')      
 axis('equal')
 hold off;
 view(views)
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
drawnow
end
